from zope.interface import implements

from Products.Maps.interfaces.marker import IMarker
from Products.Maps.interfaces.map import IMap

from Products.CMFPlone.utils import base_hasattr


class SmartFolderMap(object):
    implements(IMap)

    def __init__(self, context):
        self.context = context

    def getMarkers(self):
        rawresults = self.context.queryCatalog()
        results = []
        for item in rawresults:
            marker = IMarker(item, None)
            if marker is None:
                if base_hasattr(item, 'getObject'):
                    marker = IMarker(item.getObject(), None)
            if marker is not None:
                results.append(marker)
        return results


class FolderMap(object):
    implements(IMap)

    def __init__(self, context):
        self.context = context

    def getMarkers(self):
        rawresults = self.context.getFolderContents()
        results = []
        for item in rawresults:
            marker = IMarker(item, None)
            if marker is None:
                if base_hasattr(item, 'getObject'):
                    marker = IMarker(item.getObject(), None)
            if marker is not None:
                results.append(marker)
        return results
