#
# GE Setup Tests
#

from Testing import ZopeTestCase
from Products.Maps.tests import MapsTestCase
from Products.Maps.Extensions import Install # To catch errors in install method
from Products.CMFCore.utils import getToolByName


class TestSetup(MapsTestCase.MapsTestCase):

    def testContentTypes(self):
        types = self.portal.portal_types.objectIds()
        contents = ['GeoLocation']
        for content in contents:
            self.failUnless(content in types, '%s not installed' % content)

    def testPortalFactory(self):
        factory = self.portal.portal_factory
        types = factory.getFactoryTypes().keys()
        # Factory types
        contents = ['GeoLocation']
        for content in contents:
            self.failUnless(content in types, '%s not registered with portal factory' % content)
        # Not factory types (for copying last weeks data)
        contents = []
        for content in contents:
            self.failIf(content in types, '%s erroneously registered with portal factory' % content)

    def testSkinDirsInstalled(self):
        skinstool = getToolByName(self.portal, 'portal_skins')
        skins = skinstool.objectIds()
        ourSkins = [ 'Maps' ]
        for thisSkin in ourSkins:
            self.failUnless(thisSkin in skins, "%s skin not created automatically" % thisSkin)


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestSetup))
    return suite
